package com.university;
import java.util.*;

public class Department {

    private String name;
    private ArrayList<Student> students;
    private ArrayList<Course> courses;
    private ArrayList<Professor> professors;

    public Department(String name) {
        this.name = name;
        students = new ArrayList<>();
        courses = new ArrayList<>();
        professors = new ArrayList<>();
    }

    public String getName(){
        return name;
    }

    public void addStudent(Student student){
        if(student.getDepartment() == this)
            students.add(student);
    }

    public Student[] getStudents(){
        Student[] arr = new Student[students.size()];
        return students.toArray(arr);
    }

    public void removeStudent(Student student){
        students.remove(student);
    }

    public void addCourse(Course course){
        if(course.getDepartment() == this)
            courses.add(course);
    }

    public Course[] getCourses(){
        Course[] arr = new Course[courses.size()];
        return courses.toArray(arr);
    }

    public void removeCourse(Course course){
        courses.remove(course);
    }

    public void addProfessor(Professor professor){
        if(professor.getDepartment() == this)
            professors.add(professor);
    }

    public Professor[] getProfessors(){
        Professor[] arr = new Professor[professors.size()];
        return professors.toArray(arr);
    }

    public void removeProfessor(Professor professor){
        professors.remove(professor);
    }

}
