package test;

import com.university.Course;
import com.university.Department;
import com.university.Professor;
import com.university.Student;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class CourseTest {

    static Course course;
    static Department department;
    static Professor professor;

    @BeforeAll
    public static void createCourseTest(){
        department = new Department("salam");
        professor = new Professor(department, "hajit");
        course = new Course("12", "man", department, professor, 0);

    }

    @Test
    void getID() {
        assertEquals(course.getID(), "12");
    }

    @Test
    void getDepartment() {
        assertEquals(course.getDepartment(), department);
    }

    @Test
    void getName() {
        assertEquals(course.getName(), "man");
    }

    @Test
    void getStudents() {
        assertNotEquals(null, course.getStudents());
    }

    @Test
    void getProfessor() {
        assertEquals(course.getProfessor(), professor);
    }

    @Test
    void enrollStudent() {
        Student shouldadd = new Student("A", "B", "C", department);
        Student shouldnotadd = new Student("A", "B", "C", null);
        course.enrollStudent(shouldadd);
        course.enrollStudent(shouldnotadd);
        assertEquals(1, course.getStudents().length);
        assertEquals(course.getStudents()[0], shouldadd);
    }
}