package test;

import com.university.Course;
import com.university.Department;
import com.university.Professor;
import com.university.Student;
import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class DepartmentTest {

    static Department department;

    @BeforeAll
    public static void createDepartment() {
        department = new Department("salam");
    }

    @Test
    void getName() {
        assertEquals("salam", department.getName());
    }

    @Test
    void addStudent() {
        Student student = new Student("A", "B", "C", department);
        Student notstudent = new Student("A", "B", "C", null);
        department.addStudent(student);
        department.addStudent(notstudent);
        assertEquals(1, department.getStudents().length);
        assertEquals(department.getStudents()[0], student);
    }

    @Test
    void getStudents() {
        assertNotEquals(null, department.getStudents());
    }

    @Test
    void removeStudent() {
        Student student = new Student("A", "B", "C", department);
        int len = department.getStudents().length;
        department.removeStudent(student);
        assertEquals(len, department.getStudents().length);
        department.addStudent(student);
        department.removeStudent(department.getStudents()[0]);
        assertEquals(len, department.getStudents().length);
    }

    @Test
    void addCourse() {
        Course course = new Course("12", "12", department, null, 0);
        Course notcourse = new Course("12", "12", null, null, 0);
        department.addCourse(course);
        department.addCourse(notcourse);
        assertEquals(1, department.getCourses().length);
        assertEquals(department.getCourses()[0], course);
    }

    @Test
    void getCourses() {
        assertNotEquals(department.getCourses()[0], null);
    }

    @Test
    void removeCourse() {
        Course course = new Course("12", "12", department, null, 0);
        int len = department.getCourses().length;
        department.removeCourse(course);
        assertEquals(len, department.getCourses().length);
        department.addCourse(course);
        department.removeCourse(department.getCourses()[0]);
        assertEquals(len, department.getCourses().length);
    }

    @Test
    void addProfessor() {
        Professor professor = new Professor(department, "A");
        Professor notprofessor = new Professor(null, "A");
        department.addProfessor(professor);
        department.addProfessor(notprofessor);
        assertEquals(1, department.getProfessors().length);
        assertEquals(department.getProfessors()[0], professor);
    }

    @Test
    void getProfessors() {
        assertNotEquals(null, department.getProfessors());
    }

    @Test
    void removeProfessor() {
        Professor professor = new Professor(department, "A");
        int len = department.getProfessors().length;
        department.removeProfessor(professor);
        assertEquals(len, department.getProfessors().length);
        department.removeProfessor(department.getProfessors()[0]);
        assertEquals(len-1, department.getProfessors().length);
    }
}