package test;

import com.university.Course;
import com.university.Department;
import com.university.Student;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;


public class StudnetTest {
    static Student student;
    static Department department;

    @BeforeAll
    public static void createStudent(){
        department = new Department("Computer and IT Eng");
        student = new Student("Alireza", "1234", "Software Eng", department);
    }

    @Test
    public void testStudentGetName(){
        assertEquals("Alireza", student.getName());
    }

    @Test
    public void testStudenGetCourses(){
        assertNotNull(student.getCourses());
        assertEquals(0, student.getCourses().length);
    }

    @Test
    public void testGetDepartment(){
        assertEquals(department, student.getDepartment());
    }

    @Test
    public void testGetMajor(){
        assertEquals(student.getMajor(), "Software Eng");
    }

    @Test
    public void testAddCourse(){
        Course course = new Course("1", "1", department, null, 0);
        student.addCourse(course);
        assertEquals(student.getCourses()[0], course);
        student.clearCourses();
    }
}
